seccomp: add cacheflush to whitelist
[qemu/ar7.git] / tests / qemu-iotests / common.config
blob3ed51b8baa249701f5b3e6bef8e1a5fb33b691d3
1 #!/bin/bash
3 # Copyright (C) 2009 Red Hat, Inc.
4 # Copyright (c) 2000-2003,2006 Silicon Graphics, Inc. All Rights Reserved.
6 # This program is free software; you can redistribute it and/or
7 # modify it under the terms of the GNU General Public License as
8 # published by the Free Software Foundation.
10 # This program is distributed in the hope that it would be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see <http://www.gnu.org/licenses/>.
19 # setup and check for config parameters, and in particular
21 # EMAIL - email of the script runner.
22 # TEST_DIR - scratch test directory
24 # - These can be added to $HOST_CONFIG_DIR (witch default to ./config)
25 # below or a separate local configuration file can be used (using
26 # the HOST_OPTIONS variable).
27 # - This script is shared by the stress test system and the auto-qa
28 # system (includes both regression test and benchmark components).
29 # - this script shouldn't make any assertions about filesystem
30 # validity or mountedness.
33 # all tests should use a common language setting to prevent golden
34 # output mismatches.
35 export LANG=C
37 PATH=".:$PATH"
39 HOST=`hostname -s 2> /dev/null`
40 HOSTOS=`uname -s`
42 EMAIL=root@localhost # where auto-qa will send its status messages
43 export HOST_OPTIONS=${HOST_OPTIONS:=local.config}
44 export CHECK_OPTIONS=${CHECK_OPTIONS:="-g auto"}
45 export PWD=`pwd`
47 export _QEMU_HANDLE=0
49 # $1 = prog to look for, $2* = default pathnames if not found in $PATH
50 set_prog_path()
52 p=`command -v $1 2> /dev/null`
53 if [ -n "$p" -a -x "$p" ]; then
54 echo $p
55 return 0
57 p=$1
59 shift
60 for f; do
61 if [ -x $f ]; then
62 echo $f
63 return 0
65 done
67 echo ""
68 return 1
71 _fatal()
73 echo "$*"
74 status=1
75 exit 1
78 export PERL_PROG="`set_prog_path perl`"
79 [ "$PERL_PROG" = "" ] && _fatal "perl not found"
81 export AWK_PROG="`set_prog_path awk`"
82 [ "$AWK_PROG" = "" ] && _fatal "awk not found"
84 export SED_PROG="`set_prog_path sed`"
85 [ "$SED_PROG" = "" ] && _fatal "sed not found"
87 export BC_PROG="`set_prog_path bc`"
88 [ "$BC_PROG" = "" ] && _fatal "bc not found"
90 export PS_ALL_FLAGS="-ef"
92 if [ -z "$QEMU_PROG" ]; then
93 export QEMU_PROG="`set_prog_path qemu`"
96 if [ -z "$QEMU_IMG_PROG" ]; then
97 export QEMU_IMG_PROG="`set_prog_path qemu-img`"
100 if [ -z "$QEMU_IO_PROG" ]; then
101 export QEMU_IO_PROG="`set_prog_path qemu-io`"
104 if [ -z "$QEMU_NBD_PROG" ]; then
105 export QEMU_NBD_PROG="`set_prog_path qemu-nbd`"
108 _qemu_wrapper()
111 if [ -n "${QEMU_NEED_PID}" ]; then
112 echo $BASHPID > "${TEST_DIR}/qemu-${_QEMU_HANDLE}.pid"
114 exec "$QEMU_PROG" $QEMU_OPTIONS "$@"
118 _qemu_img_wrapper()
120 (exec "$QEMU_IMG_PROG" $QEMU_IMG_OPTIONS "$@")
123 _qemu_io_wrapper()
125 local VALGRIND_LOGFILE=/tmp/$$.valgrind
126 local RETVAL
128 if [ "${VALGRIND_QEMU}" == "y" ]; then
129 exec valgrind --log-file="${VALGRIND_LOGFILE}" --error-exitcode=99 "$QEMU_IO_PROG" $QEMU_IO_OPTIONS "$@"
130 else
131 exec "$QEMU_IO_PROG" $QEMU_IO_OPTIONS "$@"
134 RETVAL=$?
135 if [ "${VALGRIND_QEMU}" == "y" ]; then
136 if [ $RETVAL == 99 ]; then
137 cat "${VALGRIND_LOGFILE}"
139 rm -f "${VALGRIND_LOGFILE}"
141 (exit $RETVAL)
144 _qemu_nbd_wrapper()
147 echo $BASHPID > "${TEST_DIR}/qemu-nbd.pid"
148 exec "$QEMU_NBD_PROG" $QEMU_NBD_OPTIONS "$@"
152 export QEMU=_qemu_wrapper
153 export QEMU_IMG=_qemu_img_wrapper
154 export QEMU_IO=_qemu_io_wrapper
155 export QEMU_NBD=_qemu_nbd_wrapper
157 default_machine=$($QEMU -machine \? | awk '/(default)/{print $1}')
158 default_alias_machine=$($QEMU -machine \? |\
159 awk -v var_default_machine="$default_machine"\)\
160 '{if ($(NF-2)=="(alias"&&$(NF-1)=="of"&&$(NF)==var_default_machine){print $1}}')
161 if [ ! -z "$default_alias_machine" ]; then
162 default_machine="$default_alias_machine"
165 export QEMU_DEFAULT_MACHINE="$default_machine"
167 [ -f /etc/qemu-iotest.config ] && . /etc/qemu-iotest.config
169 if [ -z "$TEST_DIR" ]; then
170 TEST_DIR=`pwd`/scratch
173 if [ ! -e "$TEST_DIR" ]; then
174 mkdir "$TEST_DIR"
177 if [ ! -d "$TEST_DIR" ]; then
178 echo "common.config: Error: \$TEST_DIR ($TEST_DIR) is not a directory"
179 exit 1
182 export TEST_DIR
184 if [ -z "$SAMPLE_IMG_DIR" ]; then
185 SAMPLE_IMG_DIR="$source_iotests/sample_images"
188 if [ ! -d "$SAMPLE_IMG_DIR" ]; then
189 echo "common.config: Error: \$SAMPLE_IMG_DIR ($SAMPLE_IMG_DIR) is not a directory"
190 exit 1
193 export SAMPLE_IMG_DIR
195 _readlink()
197 if [ $# -ne 1 ]; then
198 echo "Usage: _readlink filename" 1>&2
199 exit 1
202 perl -e "\$in=\"$1\";" -e '
203 $lnk = readlink($in);
204 if ($lnk =~ m!^/.*!) {
205 print "$lnk\n";
207 else {
208 chomp($dir = `dirname $in`);
209 print "$dir/$lnk\n";
213 # make sure this script returns success
214 true